/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMPREBASE                                              */
/* Tabela : ITEMPREBASE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMPREBASE' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMPREBASE
GO

CREATE TRIGGER DTULTATU_ITEMPREBASE
ON ITEMPREBASE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ITEMPREBASE', null, 'CDPRECOBASE='+ CDPRECOBASE + ';'+
                                          'DTINIVALIPB='+ CONVERT(CHAR,DTINIVALIPB,120)+ ';'+
                                          'CDPRODUTO='  + CDPRODUTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ITEMPREBASE
      SET DTULTATUIPRE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ITEMPREBASE.CDPRECOBASE,0)  = ISNULL(INSERTED.CDPRECOBASE,0)) AND
            (ISNULL(ITEMPREBASE.DTINIVALIPB,CONVERT(DATETIME,'31/12/1899')) =
                ISNULL(INSERTED.DTINIVALIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ITEMPREBASE.DTFIMVALIPB,CONVERT(DATETIME,'31/12/1899')) =
            ISNULL(INSERTED.DTFIMVALIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ITEMPREBASE.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(ITEMPREBASE.VRITEPREBASE,0) = ISNULL(INSERTED.VRITEPREBASE,0)) AND
            (ISNULL(ITEMPREBASE.DTHRATZIPB,CONVERT(DATETIME,'31/12/1899')) =
                ISNULL(INSERTED.DTHRATZIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ITEMPREBASE.CDOPERATZIPB,0) = ISNULL(INSERTED.CDOPERATZIPB,0));
            
      UPDATE PRODWEBSYNC
      SET DTULTALTPROD = GETDATE(), IDATUALIZADO = 'N'
      FROM INSERTED
      WHERE (ISNULL(ITEMPREBASE.DTINIVALIPB,CONVERT(DATETIME,'31/12/1899')) =
                ISNULL(INSERTED.DTINIVALIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ITEMPREBASE.DTFIMVALIPB,CONVERT(DATETIME,'31/12/1899')) =
                ISNULL(INSERTED.DTFIMVALIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(ITEMPREBASE.VRITEPREBASE,0) = ISNULL(INSERTED.VRITEPREBASE,0))
            (PRODWEBSYNC.CDPRODUTO = INSERTED.CDPRODUTO);
   END;
END;
GO

